<?php
/**
 * projects Action Plugin: hajacking the modification of wiki pages
 *
 * @author     Junling Ma <junlingm@gmail.com>
 */
 
require_once(dirname(__FILE__).'/../lib/project.php');
require_once DOKU_PLUGIN.'action.php';
 
class action_plugin_projects_media extends DokuWiki_Action_Plugin {

	function getInfo(){
		return array(
		 'author' => 'Junling Ma',
		 'email'  => 'junlingm@gmail.com',
		 'date'   => '2010-12-15',
		 'name'   => 'Projects',
		 'desc'   => 'Manage the projects media files',
		 'url'    => 'http://www.math.uvic.ca/~jma'
		 );
	}
 
    /**
     * Register its handlers with the DokuWiki's event controller
     */
    function register(&$controller) {
        $controller->register_hook('FETCH_MEDIA_STATUS', 'BEFORE', $this,
                                   'fetching');
    }
 
    /**
     * a media file is requested
     *
     */
    function fetching(&$event, $param) {
    	$media = $event->data['media'];
    	$path = explode(":", $media);
    	$media_path = implode('/', $path);
    	$file = $event->data['file'];
    	$orig = $event->data['orig'];
    	$status = $event->data['status'];
    	if ($status == 404) {
    		$event->data['file'] = DOKU_DATA . $media_path;
    		$event->data['orig'] = $event->data['file'];
    		$event->data['status'] = 200;
    		$event->data['cache'] = 0;
    		$event->data['download'] = NULL;
    		$event->data['statusmessage'] = NULL;
		}
	}
		
}

?>