<?php

// adapted from http://www.dreamincode.net/code/snippet1666.htm

class Mutex {
	private $filename = NULL;			// The file to be locked
	private $locked = false;
	
	/* Constructor */
	function __construct($filename){
		// Append '.lck' extension to filename for the locking mechanism
		$this->filename = $filename . '.lock';
	}
	
	function __destruct() { $this->release(); }
	/* Methods */
	
	function acquire($block = true, $timeout = 1){
		// Create the locked file, the 'x' parameter is used to detect a preexisting lock
		global $INFO;
		global $ID;
		append_debug();
		fprintf(debug_fd(), "locking for $ID\n");
		for ($i = 0; $i < $timeout; $i++) {
			$fp = @fopen($this->filename, 'x');
			// If an error occurs fail lock
			if($fp && @fwrite($fp, $INFO['userinfo']['name'])) {
				@fclose($fp);
				fprintf(debug_fd(), "locked\n");
				$this->locked = true;
				return true;
			}
			if (!$block) break;
			sleep(1);
		}
		fprintf(debug_fd(), "failed\n");
		$this->locked = false;
		return false;
	}
	
	function release(){
		// Delete the file with the extension '.lck'
		if ($this->locked) @unlink($this->filename);
		global $ID;
		append_debug();
		fprintf(debug_fd(), "unlocking for $ID\n");
		$this->locked = false;
	}	
}
?>