<?php

require_once(dirname(__FILE__).'/../../lib/plugins.php');
require_once(dirname(__FILE__).'/../../lib/project_file.php');

class projects_plugin_media extends MakeRule {
	/**
	 * The name of the rule, a human readable string, a unique identifier
	 */
	public function name() { return "MediaLibrary"; }
	
	/**
	 * whether this rule can make a given target
	 */
	public function can_handle($project, $file) {
		return file_exists(media_path($project->name(), $file->name())); 
	}

	/** 
	 * returns a project file that can make $name
	 */
	public function handle($project, $file) {
		$id = $project->name() . ":" . $file->name();
		$def = new CrosslinkDefinition(array(
			'name' => $file->name(), 
			'type' => CROSSLINK, 
			'linkto' => "[media]:$id"));
		return ProjectFile::create($project, $def);
	}

}

?>